#include <assert.h>
#include <fstream>
#include <algorithm>

ifstream in ("maze.in");

static int m[256][256][4], b[256][256], used[256][256];
int sx, sy;

int dfs (int x, int y, int depth, int dir)
{
  // cout << x << " " << y << " " << depth << " " << dir << endl;
  if (b[x][y]) return -1;
  if (used[x][y]) return depth;
  used[x][y] = 1;

  if (m[x][y][0] && ((x==sx && y==sy) || dir != 2))
  {
    int d = dfs (x, y+1, depth+1, 0);
    if (d == -1) { b[x][y] = 1; return -1; }
    if (d > 0) return d;
  }

  if (m[x][y][1] && ((x==sx && y==sy) || dir != 3))
  {
    int d = dfs (x+1, y, depth+1, 1);
    if (d == -1) { b[x][y] = 1; return -1; }
    if (d > 0) return d;
  }

  if (m[x][y][2] && ((x==sx && y==sy) || dir != 0))
  {
    int d = dfs (x, y-1, depth+1, 2);
    if (d == -1) { b[x][y] = 1; return -1; }
    if (d > 0) return d;
  }

  if (m[x][y][3] && ((x==sx && y==sy) || dir != 1))
  {
    int d = dfs (x-1, y, depth+1, 3);
    if (d == -1) { b[x][y] = 1; return -1; }
    if (d > 0) return d;
  }

  assert (0);
  return 0;
}

main ()
{
  int kase = 0;
  int w, h;
  while (in >> w >> h)
  {
    if (w == 0 && h == 0) break;
    cout << "Maze #" << ++kase << ":" << endl;
    if (w == 0 || h == 0)
    {
      cout << "There are no cycles." << endl;
      continue;
    }
    int ncycle = 0, maxcycle = 0;
    // input
    for (int i=0 ; i<256 ; i++)
      for (int j=0 ; j<256 ; j++)
      {
        for (int k=0 ; k<4 ; k++)
          m[i][j][k] = 1;
        b[i][j] = 0;
        used[i][j] = 0;
      }
    for (int i=0 ; i<h ; i++)
    {
      int x = i;
      int y = 128 - i;
      for (int j=0 ; j<w ; j++)
      {
        char ch;
        in >> ws >> ch;
        if (ch == '/')
        {
          m[x][y][1] = m[x+1][y][3] = m[x][y-1][1] = m[x+1][y-1][3] = 0;
        }
        else
        {
          m[x][y][2] = m[x+1][y][2] = m[x][y-1][0] = m[x+1][y-1][0] = 0;
        }
        x++;
        y++;
      }
    }

    // init border
    for (int i=0 ; i<w ; i++)
    {
      b[i][128+i] = 1;
      for (int k=0 ; k<4 ; k++)
        m[i][128+i][k] = 0;
      b[h+i][128-h+i] = 1;
      for (int k=0 ; k<4 ; k++)
        m[h+i][128-h+i][k] = 0;
    }

    // init border
    for (int j=0 ; j<h ; j++)
    {
      b[j][127-j] = 1;
      for (int k=0 ; k<4 ; k++)
        m[j][127-j][k] = 0;
      b[w+j][128+w-1-j] = 1;
      for (int k=0 ; k<4 ; k++)
        m[w+j][128+w-1-j][k] = 0;
    }
    /*
    for (int x=5 ; x<7 ; x++)
      for (int y=129 ; y<131 ; y++)
      {
        for (int k=0 ; k<4 ; k++)
          cout << m[x][y][k] << " ";
        cout << b[x][y] << endl;
      }
      */

    for (int i=0 ; i<w ; i++)
      for (int j=0 ; j<h ; j++)
      {
        int x = i+j;
        int y = 128+i-j;
        sx = x;
        sy = y;
        // cout << x << " "<< y << endl;

        int d = dfs (x, y, 0, 0);
        if (d > 0)
        {
          // cout << x << " " << y << endl;
          ncycle++;
          maxcycle = max (maxcycle, d);
        }

        if (i == w-1) continue;
        d = dfs (x+1, y, 0, 0);
        if (d > 0)
        {
          ncycle++;
          maxcycle = max (maxcycle, d);
        }

      }
    if (ncycle == 0)
      cout << "There are no cycles." << endl;
    else
      cout << ncycle << " Cycles; the longest has length " << maxcycle << "." << endl;
    cout << endl;
  }
  return 0;
}

